diff --git a/src/etc/inc/pfsense-utils.inc b/src/etc/inc/pfsense-utils.inc
index e45d5ffc6b7e2dd6b7df7077872b63f24e69d13f..40a4852cf49f3cdf64415f89dc94290345f09a7a 100644
--- a/src/etc/inc/pfsense-utils.inc
+++ b/src/etc/inc/pfsense-utils.inc
@@ -3196,6 +3196,15 @@ function calculate_ipv6_delegation_length($if) {
 function merge_ipv6_delegated_prefix($prefix, $suffix, $len = 64) {
 	$prefix = Net_IPv6::uncompress($prefix, true);
 	$suffix = Net_IPv6::uncompress($suffix, true);
+	/* convert zero-value prefix IPv6 addresses with IPv4 mapping to hex
+	 * see https://redmine.pfsense.org/issues/12440 */
+	$suffix_list = explode(':', $suffix);
+	if (is_ipaddrv4($suffix_list[count($suffix_list) - 1])) {
+		$hexsuffix = dechex(ip2long($suffix_list[count($suffix_list) - 1]));
+		$suffix_list[count($suffix_list) - 2] = substr($hexsuffix, 0, 4);
+		$suffix_list[count($suffix_list) - 1] = substr($hexsuffix, 4, 8);
+		$suffix = implode(':', $suffix_list);
+	}	
 
 	/*
 	 * xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:xxxx
